package com.zyzf.coffeepreorder.database

import android.content.Context
import com.zyzf.coffeepreorder.database.repository.CartRepository
import com.zyzf.coffeepreorder.database.repository.CoffeeRepository
import com.zyzf.coffeepreorder.database.repository.OfflineCartRepository
import com.zyzf.coffeepreorder.database.repository.OfflineCoffeeRepository
import com.zyzf.coffeepreorder.database.repository.OfflineUserRepository
import com.zyzf.coffeepreorder.database.repository.UserRepository

interface AppContainer {
    val coffeeRepository: CoffeeRepository
    val userRepository: UserRepository
    val cartRepository: CartRepository
}

class AppDataContainer(private val context: Context) : AppContainer {
    override val coffeeRepository: CoffeeRepository by lazy {
        OfflineCoffeeRepository(AppDatabase.getInstance(context).coffeeDao())
    }
    override val userRepository: UserRepository by lazy {
        OfflineUserRepository(AppDatabase.getInstance(context).userDao())
    }
    override val cartRepository: CartRepository by lazy {
        OfflineCartRepository(AppDatabase.getInstance(context).cartDao())
    }

    companion object {
        const val TIMEOUT = 5000L
    }
}