package com.zyzf.coffeepreorder.database.dao

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import com.zyzf.coffeepreorder.database.model.Cart

@Dao
interface CartDao {
    @Query("select * from cart limit 1")
    suspend fun get(): Cart

    @Insert
    suspend fun insert(cart: Cart)

    @Query("update coffee set cart_id = :cartId, count = count + :count where uid = :coffeeId")
    suspend fun insertCoffee(cartId: Int, coffeeId: Int, count: Int)

    @Query("update coffee set count = count - :count where uid = :coffeeId")
    suspend fun deleteCoffee(coffeeId: Int, count: Int)

    @Update
    suspend fun update(cart: Cart)

    @Query("delete from cart")
    suspend fun deleteAll()
}