package com.zyzf.coffeepreorder.database.repository

import com.zyzf.coffeepreorder.database.model.Coffee
import com.zyzf.coffeepreorder.database.model.CoffeeWithCart
import kotlinx.coroutines.flow.Flow

interface CoffeeRepository {
    fun getAll(): Flow<List<Coffee>>
    fun getAllInCart(): Flow<List<Coffee>>
    fun getSumInCart(): Double
    suspend fun getByUid(uid: Int): CoffeeWithCart?
    suspend fun insert(name: String, cost: Double, ingredients: String): Long
    suspend fun update(uid: Int, name: String, cost: Double, ingredients: String, cartId: Int?, count: Int): Int?
    suspend fun delete(coffee: Coffee)
}