package com.zyzf.coffeepreorder.database.repository

import com.zyzf.coffeepreorder.database.dao.CartDao
import com.zyzf.coffeepreorder.database.model.Cart

class OfflineCartRepository(private val cartDao: CartDao) : CartRepository {
    override suspend fun get(): Cart = cartDao.get()
    override suspend fun insert(cart: Cart) = cartDao.insert(cart)
    override suspend fun insertCoffee(cartId: Int, coffeeId: Int, count: Int) = cartDao.insertCoffee(cartId, coffeeId, count)
    override suspend fun deleteCoffee(coffeeId: Int, count: Int) = cartDao.deleteCoffee(coffeeId, count)
    override suspend fun update(cart: Cart) = cartDao.update(cart)
    override suspend fun deleteAll() = cartDao.deleteAll()
}