package com.zyzf.coffeepreorder.database.repository

import com.zyzf.coffeepreorder.database.dao.CoffeeDao
import com.zyzf.coffeepreorder.database.model.Coffee
import com.zyzf.coffeepreorder.database.model.CoffeeWithCart
import kotlinx.coroutines.flow.Flow

class OfflineCoffeeRepository(private val coffeeDao: CoffeeDao) : CoffeeRepository {
    override fun getAll(): Flow<List<Coffee>> = coffeeDao.getAll()
    override fun getAllInCart(): Flow<List<Coffee>> = coffeeDao.getAllInCart()
    override fun getSumInCart(): Double = coffeeDao.getSumInCart()
    override suspend fun getByUid(uid: Int): CoffeeWithCart? = coffeeDao.getByUid(uid)
    override suspend fun insert(name: String, cost: Double, ingredients: String): Long = coffeeDao.insert(name, cost, ingredients)
    override suspend fun update(uid: Int, name: String, cost: Double, ingredients: String, cartId: Int?, count: Int): Int? = coffeeDao.update(uid, name, cost, ingredients, cartId, count)
    override suspend fun delete(coffee: Coffee) = coffeeDao.delete(coffee)
}