package com.zyzf.coffeepreorder.database.repository

import com.zyzf.coffeepreorder.database.dao.UserDao
import com.zyzf.coffeepreorder.database.model.User
import kotlinx.coroutines.flow.Flow

class OfflineUserRepository(private val userDao: UserDao) : UserRepository {
    override fun getAll(): Flow<List<User>> = userDao.getAll()
    override suspend fun tryLogin(login: String, password: String): User? = userDao.tryLogin(login, password)
    override suspend fun getByUid(uid: Int): User? = userDao.getByUid(uid)
    override suspend fun getLogined(): User? = userDao.getLogined()
    override suspend fun setLogined(userId: Int) = userDao.setLogined(userId)
    override suspend fun logout() = userDao.logout()
    override suspend fun insert(user: User) = userDao.insert(user)
    override suspend fun update(uid: Int, login: String, fio: String, phone: String, password: String) : Int? = userDao.update(uid, login, fio, phone, password)
    override suspend fun delete(uid: Int) = userDao.delete(uid)
}