package com.zyzf.coffeepreorder.database.repository

import com.zyzf.coffeepreorder.database.model.User
import kotlinx.coroutines.flow.Flow

interface UserRepository {
    fun getAll(): Flow<List<User>>
    suspend fun tryLogin(login: String, password: String): User?
    suspend fun getByUid(uid: Int): User?
    suspend fun getLogined(): User?
    suspend fun setLogined(userId: Int)
    suspend fun logout()
    suspend fun insert(user: User)
    suspend fun update(uid: Int, login: String, fio: String, phone: String, password: String) : Int?
    suspend fun delete(uid: Int)
}