package com.zyzf.coffeepreorder.ui

import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.viewmodel.CreationExtras
import androidx.lifecycle.viewmodel.initializer
import androidx.lifecycle.viewmodel.viewModelFactory
import com.zyzf.coffeepreorder.CoffeeApplication
import com.zyzf.coffeepreorder.ui.coffee.CoffeeListViewModel
import com.zyzf.coffeepreorder.ui.login.LoginViewModel

object AppViewModelProvider {
    val Factory = viewModelFactory {
        initializer {
            CoffeeListViewModel(coffeeApplication().container.coffeeRepository, coffeeApplication().container.cartRepository)
        }
        initializer {
            LoginViewModel(coffeeApplication().container.userRepository)
        }
    }
}

fun CreationExtras.coffeeApplication(): CoffeeApplication =
    (this[ViewModelProvider.AndroidViewModelFactory.APPLICATION_KEY] as CoffeeApplication)